public override Value Evaluate(FSharpList <Value> args) { this.ClearPreviousResults(); //unwrap the values IEnumerable <XYZ> nvals = ((Value.List)args[0]).Item.Select( x => (XYZ)((Value.Container)x).Item ); //unwrap the sample locations IEnumerable <XYZ> pts = ((Value.List)args[1]).Item.Select( x => (XYZ)((Value.Container)x).Item ); SpatialFieldManager = ((Value.Container)args[2]).Item as Autodesk.Revit.DB.Analysis.SpatialFieldManager; int idx = SpatialFieldManager.AddSpatialFieldPrimitive(); var samplePts = new FieldDomainPointsByXYZ(pts.ToList <XYZ>()); //for every sample location add a list //of valueatpoint objects. for now, we only //support one value per point IList <VectorAtPoint> valList = nvals.Select(n => new VectorAtPoint(new List <XYZ> { n })).ToList(); var sampleValues = new FieldValues(valList); int schemaIndex = 0; if (!SpatialFieldManager.IsResultSchemaNameUnique(DYNAMO_ANALYSIS_RESULTS_NAME, -1)) { IList <int> arses = SpatialFieldManager.GetRegisteredResults(); foreach (int i in arses) { AnalysisResultSchema arsTest = SpatialFieldManager.GetResultSchema(i); if (arsTest.Name == DYNAMO_ANALYSIS_RESULTS_NAME) { schemaIndex = i; break; } } } else { var ars = new AnalysisResultSchema(DYNAMO_ANALYSIS_RESULTS_NAME, "Resulting analyses from Dynamo."); schemaIndex = SpatialFieldManager.RegisterResult(ars); } SpatialFieldManager.UpdateSpatialFieldPrimitive(idx, samplePts, sampleValues, schemaIndex); PastResultIds.Add(idx); return(Value.NewContainer(idx)); }
public override Value Evaluate(FSharpList <Value> args) { this.ClearPreviousResults(); //unwrap the values IEnumerable <double> nvals = ((Value.List)args[0]).Item.Select(q => (double)((Value.Number)q).Item); var curve = (Curve)((Value.Container)args[1]).Item; SpatialFieldManager = (Autodesk.Revit.DB.Analysis.SpatialFieldManager)((Value.Container)args[2]).Item; if (!SpatialFieldManager.IsResultSchemaNameUnique(DYNAMO_TEMP_CURVES_SCHEMA, -1)) { IList <int> arses = SpatialFieldManager.GetRegisteredResults(); foreach (int i in arses) { AnalysisResultSchema arsTest = SpatialFieldManager.GetResultSchema(i); if (arsTest.Name == DYNAMO_TEMP_CURVES_SCHEMA) { schemaId = i; break; } } } else { var ars = new AnalysisResultSchema(DYNAMO_TEMP_CURVES_SCHEMA, "Temporary curves from Dynamo."); schemaId = SpatialFieldManager.RegisterResult(ars); } Transform trf = Transform.Identity; //http://thebuildingcoder.typepad.com/blog/2012/09/sphere-creation-for-avf-and-filtering.html#3 var create = dynRevitSettings.Doc.Application.Application.Create; Transform t = curve.ComputeDerivatives(0, true); XYZ x = t.BasisX.Normalize(); XYZ y = t.BasisX.IsAlmostEqualTo(XYZ.BasisZ) ? t.BasisX.CrossProduct(XYZ.BasisY).Normalize() : t.BasisX.CrossProduct(XYZ.BasisZ).Normalize(); XYZ z = x.CrossProduct(y); Autodesk.Revit.DB.Ellipse arc1 = dynRevitSettings.Revit.Application.Create.NewEllipse(t.Origin, .1, .1, y, z, -Math.PI, 0); Autodesk.Revit.DB.Ellipse arc2 = dynRevitSettings.Revit.Application.Create.NewEllipse(t.Origin, .1, .1, y, z, 0, Math.PI); var pathLoop = new Autodesk.Revit.DB.CurveLoop(); pathLoop.Append(curve); var profileLoop = new Autodesk.Revit.DB.CurveLoop(); profileLoop.Append(arc1); profileLoop.Append(arc2); double curveDomain = curve.get_EndParameter(1) - curve.get_EndParameter(0); int idx = -1; var s = GeometryCreationUtilities.CreateSweptGeometry(pathLoop, 0, 0, new List <Autodesk.Revit.DB.CurveLoop> { profileLoop }); foreach (Face face in s.Faces) { //divide the V domain by the number of incoming BoundingBoxUV domain = face.GetBoundingBox(); double vSpan = domain.Max.V - domain.Min.V; //analysis values idx = SpatialFieldManager.AddSpatialFieldPrimitive(face, trf); //a list to hold the analysis points IList <UV> uvPts = new List <UV>(); //a list to hold the analysis values IList <ValueAtPoint> valList = new List <ValueAtPoint>(); //int count = nvals.Count(); //this is creating a lot of sample points, but if we used less //sampling points, AVF would draw the two surfaces as if there was a hard //edge between them. this provides a better blend. int count = 10; for (int i = 0; i < count; i++) { //get a UV point on the face //find its XYZ location and project to //the underlying curve. find the value which corresponds //to the location on the curve var uv = new UV(domain.Min.U, domain.Min.V + vSpan / count * (double)i); var uv1 = new UV(domain.Max.U, domain.Min.V + vSpan / count * (double)i); uvPts.Add(uv); uvPts.Add(uv1); XYZ facePt = face.Evaluate(uv); IntersectionResult ir = curve.Project(facePt); double curveParam = curve.ComputeNormalizedParameter(ir.Parameter); if (curveParam < 0) { curveParam = 0; } if (curveParam > 1) { curveParam = 1; } var valueIndex = (int)Math.Floor(curveParam * (double)nvals.Count()); if (valueIndex >= nvals.Count()) { valueIndex = nvals.Count() - 1; } //create list of values at this point - currently supporting only one //var doubleList = new List<double> { nvals.ElementAt(i) }; var doubleList = new List <double> { nvals.ElementAt(valueIndex) }; //add value at point object containing the value list valList.Add(new ValueAtPoint(doubleList)); valList.Add(new ValueAtPoint(doubleList)); } var pnts = new FieldDomainPointsByUV(uvPts); var vals = new FieldValues(valList); SpatialFieldManager.UpdateSpatialFieldPrimitive( idx, pnts, vals, schemaId); PastResultIds.Add(idx); } return(Value.NewNumber(idx)); }
public override Value Evaluate(FSharpList <Value> args) { this.ClearPreviousResults(); SpatialFieldManager = ((Value.Container)args[2]).Item as Autodesk.Revit.DB.Analysis.SpatialFieldManager; var reference = (args[3] as Value.Container).Item as Reference; var face = (reference == null) ? ((args[3] as Value.Container).Item as Face) : dynRevitSettings.Doc.Document.GetElement(reference).GetGeometryObjectFromReference(reference) as Face; //if we received a face instead of a reference //then use the reference from the face if (reference == null && face != null) { reference = face.Reference; } if (reference == null) { throw new Exception("Could not resolved a referenced for the face."); } int idx = SpatialFieldManager.AddSpatialFieldPrimitive(reference); //unwrap the sample locations IEnumerable <UV> pts = ((Value.List)args[1]).Item.Select( x => (UV)((Value.Container)x).Item ); var samplePts = new FieldDomainPointsByUV(pts.ToList <UV>()); //unwrap the values IEnumerable <double> nvals = ((Value.List)args[0]).Item.Select( x => (double)((Value.Number)x).Item ); //for every sample location add a list //of valueatpoint objects. for now, we only //support one value per point IList <ValueAtPoint> valList = nvals.Select(n => new ValueAtPoint(new List <double> { n })).ToList(); var sampleValues = new FieldValues(valList); int schemaIndex = 0; if (!SpatialFieldManager.IsResultSchemaNameUnique(DYNAMO_ANALYSIS_RESULTS_NAME, -1)) { IList <int> arses = SpatialFieldManager.GetRegisteredResults(); foreach (int i in arses) { AnalysisResultSchema arsTest = SpatialFieldManager.GetResultSchema(i); if (arsTest.Name == DYNAMO_ANALYSIS_RESULTS_NAME) { schemaIndex = i; break; } } } else { var ars = new AnalysisResultSchema(DYNAMO_ANALYSIS_RESULTS_NAME, "Resulting analyses from Dynamo."); schemaIndex = SpatialFieldManager.RegisterResult(ars); } SpatialFieldManager.UpdateSpatialFieldPrimitive(idx, samplePts, sampleValues, schemaIndex); PastResultIds.Add(idx); return(Value.NewContainer(idx)); }